Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.hp.hpl.jena.reasoner
Interface InfGraph

All Superinterfaces:
  Graph, GraphAdd

All Known Subinterfaces:
  BackwardRuleInfGraphI, ForwardRuleInfGraphI

All Known Implementing Classes:
  BaseInfGraph, BasicForwardRuleInfGraph, DIGInfGraph, FBRuleInfGraph, LPBackwardRuleInfGraph, RDFSRuleInfGraph, RETERuleInfGraph, TransitiveInfGraph

    public interface InfGraph

extends Graph

Extends the Graph interface to give additional means to query an inferred graph. Many entailments from the raw data are made to appear as if they are extract triples in the inferred graph and so appear through the normal Graph.find interface. However, here are two extensions required. Firstly, the ability to ask about global properties of the whole graph (e.g. consistency). Secondly, the ability to temporarily construct expressions (encoded in RDF) which form more complex queries.

Version:
  $Revision: 1.14 $ on $Date: 2008/01/02 12:07:00 $
Author:
  Dave Reynolds

Field Summary

Fields inherited from interface com.hp.hpl.jena.graph.Graph
`emptyGraph`

Method Summary
`ExtendedIterator` | `find(Node subject, Node property, Node object, Graph param)` An extension of the Graph.find interface which allows the caller to encode complex expressions in RDF and then refer to those expressions within the query triple.
`Graph` | `getDeductionsGraph()` Returns a derivations graph.
`java.util.Iterator` | `getDerivation(Triple triple)` Return the derivation of the given triple (which is the result of some previous find operation).
`Node` | `getGlobalProperty(Node property)` Test a global boolean property of the graph.
`Graph` | `getRawGraph()` Return the raw RDF data Graph being processed (i.e. the argument to the Reasonder.bind call that created this InfGraph).
`Reasoner` | `getReasoner()` Return the Reasoner which is being used to answer queries to this graph.
`void` | `prepare()` Perform any initial processing and caching.
`void` | `rebind()` Cause the inference graph to reconsult the underlying graph to take into account changes.
`void` | `rebind(Graph data)` Replace the underlying data graph for this inference graph and start any inferences over again.
`void` | `reset()` Reset any internal caches.
`void` | `setDerivationLogging(boolean logOn)` Switch on/off drivation logging
`boolean` | `testGlobalProperty(Node property)` A convenience version of getGlobalProperty which can only return a boolean result.
`ValidityReport` | `validate()` Test the consistency of the bound data.

Methods inherited from interface com.hp.hpl.jena.graph.Graph
`close, contains, contains, delete, dependsOn, find, find, getBulkUpdateHandler, getCapabilities, getEventManager, getPrefixMapping, getReifier, getStatisticsHandler, getTransactionHandler, isClosed, isEmpty, isIsomorphicWith, queryHandler, size`

Methods inherited from interface com.hp.hpl.jena.graph.GraphAdd
`add`

Method Detail

### getRawGraph

    Graph getRawGraph()

  Return the raw RDF data Graph being processed (i.e. the argument to the Reasonder.bind call that created this InfGraph).

### getReasoner

    Reasoner getReasoner()

  Return the Reasoner which is being used to answer queries to this graph.

### rebind

    void rebind(Graph data)

  Replace the underlying data graph for this inference graph and start any inferences over again. This is primarily using in setting up ontology imports processing to allow an imports multiunion graph to be inserted between the inference graph and the raw data, before processing.

  Parameters:
    `data` - the new raw data graph

### rebind

    void rebind()

  Cause the inference graph to reconsult the underlying graph to take into account changes. Normally changes are made through the InfGraph's add and remove calls are will be handled appropriately. However, in some cases changes are made "behind the InfGraph's back" and this forces a full reconsult of the changed data.

### prepare

    void prepare()

  Perform any initial processing and caching. This call is optional. Most engines either have negligable set up work or will perform an implicit "prepare" if necessary. The call is provided for those occasions where substantial preparation work is possible (e.g. running a forward chaining rule system) and where an application might wish greater control over when this prepration is done.

### reset

    void reset()

  Reset any internal caches. Some systems, such as the tabled backchainer, retain information after each query. A reset will wipe this information preventing unbounded memory use at the expense of more expensive future queries. A reset does not cause the raw data to be reconsulted and so is less expensive than a rebind.

### getGlobalProperty

    Node getGlobalProperty(Node property)

  Test a global boolean property of the graph. This might included properties like consistency, OWLSyntacticValidity etc. It remains to be seen what level of generality is needed here. We could replace this by a small number of specific tests for common concepts.

  Parameters:
    `property` - the URI of the property to be tested
  Returns:
    a Node giving the value of the global property, this may be a boolean literal, some other literal value (e.g. a size).

### testGlobalProperty

    boolean testGlobalProperty(Node property)

  A convenience version of getGlobalProperty which can only return a boolean result.

### validate

    ValidityReport validate()

  Test the consistency of the bound data. This normally tests the validity of the bound instance data against the bound schema data.

  Returns:
    a ValidityReport structure

### find

    ExtendedIterator find(Node subject,
                          Node property,
                          Node object,
                          Graph param)

  An extension of the Graph.find interface which allows the caller to encode complex expressions in RDF and then refer to those expressions within the query triple. For example, one might encode a class expression and then ask if there are any instances of this class expression in the InfGraph.

  Parameters:
    `subject` - the subject Node of the query triple, may be a Node in the graph or a node in the parameter micro-graph or null
    `property` - the property to be retrieved or null
    `object` - the object Node of the query triple, may be a Node in the graph or a node in the parameter micro-graph.
    `param` - a small graph encoding an expression which the subject and/or object nodes refer.

### setDerivationLogging

    void setDerivationLogging(boolean logOn)

  Switch on/off drivation logging

### getDerivation

    java.util.Iterator getDerivation(Triple triple)

  Return the derivation of the given triple (which is the result of some previous find operation). Not all reasoneers will support derivations.

  Returns:
    an iterator over Derivation records or null if there is no derivation information available for this triple.

### getDeductionsGraph

    Graph getDeductionsGraph()

  Returns a derivations graph. The rule reasoners typically create a graph containing those triples added to the base graph due to rule firings. In some applications it can useful to be able to access those deductions directly, without seeing the raw data which triggered them. In particular, this allows the forward rules to be used as if they were rewrite transformation rules.

  Returns:
    the deductions graph, if relevant for this class of inference engine or null if not.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008 Hewlett-Packard Development Company, LP